<template>
  <q-page class="row justify-center content-start bg-blue-grey-1 q-pa-xl">
    <div class="row justify-between col-12 q-pb-lg">
      <div
        class="text-h4 text-bold text-primary self-end"
        v-text="'Categorias'"
      />

      <q-btn
        class="super-rounded-borders"
        style="width: 272px"
        label="Nova Categoria"
        color="primary"
        padding="14px"
        @click="edit()"
      />
    </div>

    <table-view
      class="col-12"
      :columns="columns"
      :table-data="tableData"
      :types="types"
      sort-by="isEnable"
      @reload="asyncReload('tableData')"
    />
  </q-page>
</template>

<script>
import TableView from 'components/category/table-view'
import FormCategory from 'components/category/form-category'
import _ from 'lodash'

const formFactory = JSON.stringify({
  label: '',
  sublabel: '',
  color: '#9e9e9e',
  icon: '',
  type: 'video'
})

export default {
  name: 'PageCategories',
  components: { TableView },
  asyncData: {
    tableDataDefault: [],
    async tableData () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Categories'
        }

        return this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    }
  },
  data () {
    return {
      columns: [
        { name: 'id', field: 'id', label: '#', align: 'left', sortable: true },
        { name: 'label', field: 'label', label: 'Nome', align: 'left', sortable: true },
        { name: 'sublabel', field: 'sublabel', label: 'Descrição', align: 'left', sortable: true },
        { name: 'type', field: 'type', label: 'Tipo', align: 'left', sortable: true, format: (value) => _.get(_.find(this.types, { value }), 'label', value) },
        { name: 'color', field: 'color', label: 'Cor', align: 'left', sortable: true },
        { name: 'icon', field: 'icon', label: 'Ícone', align: 'left', sortable: true },
        { name: 'isEnable', field: 'isEnable', label: 'Situação', align: 'left', sortable: true, format: (value) => value ? 'Ativo' : 'Inativo' },
        { name: 'action', field: 'action', label: 'Ações', align: 'center' }
      ],
      types: [
        { label: 'Vídeo', value: 'video' },
        { label: 'Avaliação', value: 'rating' }
      ]
    }
  },
  methods: {
    edit (row = JSON.parse(formFactory)) {
      this.$q.dialog({
        component: FormCategory,
        value: Object.assign({}, row),
        options: this.types,
        parent: this
      }).onOk(() => {
        this.asyncReload('tableData')
      })
    }
  }
}
</script>
